function [diff,ks] = diseq(r,par,z,shocks)
k = zeros(par.T,1);
save parametervalues r par

%Saves parameter values to a file that will be read by Dynare
%recall that par is a structure with all other parameter values

dynare Aiyagari_full noclearall
%Runs Dynare
load dynarerocks
%Loads the decision rules to a matrix called 'decision'. Requires
%alternative disp_dr.m file (from Wouter's website).

z = ones(par.T,1);
for t=2:par.T
    z(t) = 1-par.rho + par.rho*z(t-1)+shocks(t);
end
    
kss = (par.beta*par.alpha/(1-par.beta*(1-par.delta)))^(1/(1-par.alpha));
k(1) = kss;
for t = 2:par.T
   k(t)=decision(1)+decision(3)*(k(t-1)-decision(1))...
       +decision(4)*(z(t)-1)+decision(5)*shocks(t)...
       +decision(6)*(k(t-1)-decision(1))^2+decision(7)*(k(t-1)-decision(1))*(z(t)-1)...
       +decision(8)*(z(t)-1)^2+decision(9)*shocks(t)^2 ...
       +decision(10)*shocks(t)*(k(t-1)-decision(1))...
       +decision(11)*shocks(t)*(z(t-1)-1);
end
    
ks        = mean(k(par.T0:end));            % average capital supply (from HH problem)
kd        = (r/par.alpha)^(1/(par.alpha-1));    % implied capital
diff      = ks-kd;